/*
	input: general input device and data definition
	
	This file provides the new_input_device function choosing a special class according to the type string.
	This is also very dumb code that I don't really like.
	But it does it's job.
	
	part of DerMixD
	(c)2004-7 Thomas Orgis, licensed under GPLv2
*/

#include "common.hxx"

#include "audio_buffer.hxx"
#include "audio_fifo.hxx"
#include "input.hxx"

#include "in_dummy.hxx"
#include "in_sine.hxx"
#include "in_mpg123.hxx"
#ifdef IN_VORBISFILE
#include "in_vorbisfile.hxx"
#endif
#include "in_raw_s16.hxx"
#ifdef IN_SNDFILE
#include "in_sndfile.hxx"
#endif
input_device* new_input_device(string type, input_data& data)
{
	if(strcasecmp(type.c_str(), mpg123_input::t.c_str()) == 0) return new mpg123_input(&data);
#ifdef IN_VORBISFILE
	else if(strcasecmp(type.c_str(), vorbisfile_input::t.c_str()) == 0) return new vorbisfile_input(&data);
#endif
	else if(strcasecmp(type.c_str(), raw_s16_input::t.c_str()) == 0) return new raw_s16_input(&data);
	else if(strcasecmp(type.c_str(), dummy_input::t.c_str()) == 0) return new dummy_input(&data);
	else if(strcasecmp(type.c_str(), sine_input::t.c_str()) == 0) return new sine_input(&data);
#ifdef IN_SNDFILE
	else if(strcasecmp(type.c_str(), sndfile_input::t.c_str()) == 0) return new sndfile_input(&data);
#endif
	else return NULL;
}
