#ifndef DMD_H_OUT_ALSA
#define DMD_H_OUT_ALSA

/*
	out_alsa: alsa output device
	
	part of DerMixD
	(c)2005 Thomas Orgis, licensed under GPLv2
*/

#include <alsa/asoundlib.h>

typedef struct alsa_writerextra
{
	snd_pcm_t* volatile handle;
	audio_type* ptr;
	int cptr;
	int err;
	int id;
} alsa_writerextra;

class alsa_output: public output_device
{
	private:
		int fd;
		snd_pcm_hw_params_t *hwparams;
		snd_pcm_t *pcm_handle;
		snd_pcm_stream_t stream;
		alsa_writerextra wextra;
		string current_type;
		
		bool special_init();
		void special_exit();
		bool special_activate();
		void special_deactivate();
		void special_pause();
		void special_write();
		
	public:
		static const string t;
		alsa_output(output_data* odi, unsigned int bufsize, const string type);
		~alsa_output();
		string type(){ return t; };
};

#endif
