#ifndef DMD_H_H_TSTRING
#define DMD_H_H_TSTRING
/*
	tstring: a C++ STL string that can do sprintf on itself

	part of DerMixD
	(c)2008 Thomas Orgis, licensed under GPLv2
*/
#include <vector>
#include <string>
#include <cstdarg>
#include <cerrno>
#include <cstdlib>
#include "debug.hxx"

// No specific data that could leak: STL string's destructor is not virtual.
// I want to make sure that I can still use a tstring pointer as a string pointer,
// so there is nothing to be destroyed here: ~tstring is _not_ called through deleting a string!
class tstring: public std::string
{
	public:
	tstring(const char* init)       : std::string(init){};
	tstring(const std::string &init): std::string(init){};
	tstring(): std::string(){};
	~tstring(){};
	tstring& sprintf(const char *fmt, ...);
};

// Copy tstring vector to string vector.
void tstring_v_string(std::vector<tstring*> &tt, std::vector<std::string*> &st);

#endif
